/// @file acumon/acquisition_info.c

// Copyright (c) 2008-2009 Acumem AB.  All rights reserved.

#include <assert.h>

#include "am_assert.hh"
#include "os_dependent.hh"
#include "acquisition_info.hh"

void
append_burst_start(acq_handle_t *acq_handle,
		   unsigned int burst_generation,
		   uint64_t burst_sampling_length,
		   uint64_t burst_cooldown_length)
{

    if (acq_handle == NULL)
	return;

    acq_burst_begin_t acq_burst_begin;
    acq_burst_begin.burst_generation = burst_generation;
    acq_burst_begin.burst_start_time = get_time();
    acq_burst_begin.burst_sampling_length = burst_sampling_length;
    acq_burst_begin.burst_cooldown_length = burst_cooldown_length;

    acq_write_burst_begin(acq_handle, &acq_burst_begin);
}

/* Append a burst end entry. */
void append_burst_end(acq_handle_t *acq_handle,
		      unsigned int burst_generation)
{
    if (acq_handle == NULL)
	return;

    acq_burst_end_t acq_burst_end;
    acq_burst_end.burst_generation = burst_generation;
    acq_burst_end.burst_end_time = get_time();

    acq_write_burst_end(acq_handle, &acq_burst_end);
}
