/// @file acumon/binaries.h

// Copyright (c) 2007-2008, 2010 Acumem AB.  All rights reserved.

#ifndef BINARIES_H
#define BINARIES_H

BEGIN_EXTERN_C

/* The instrumenter binaries and their size. */
extern char instr_32_bin[];
extern unsigned int instr_32_bin_size;
#if defined(__x86_64__)
extern char instr_64_bin[];
extern unsigned int instr_64_bin_size;
#endif

/* The instrumenter loader binaries. */
extern am_code_buf_t instrumenter_loader_bin_32;
#if defined(__x86_64__)
extern am_code_buf_t instrumenter_loader_bin_64;
#endif

/* The thread instrumenter binaries. */
extern am_code_buf_t thread_instrumenter_bin_32;
#if defined(__x86_64__)
extern am_code_buf_t thread_instrumenter_bin_64;
#endif

/* The thread deinstrumenter binaries. */
extern am_code_buf_t thread_deinstrumenter_bin_32;
#if defined(__x86_64__)
extern am_code_buf_t thread_deinstrumenter_bin_64;
#endif

/* The instrumenter unloader binaries. */
extern am_code_buf_t instrumenter_unloader_bin_32;
#if defined(__x86_64__)
extern am_code_buf_t instrumenter_unloader_bin_64;
#endif

END_EXTERN_C;

#endif /* BINARIES_H */
