/// @file acumon/licensing.h

// Copyright (c) 2010 Acumem AB.  All rights reserved.

#include "library/control/control.h"

BEGIN_EXTERN_C;

/* Number of allowed threads without the unlimited threads feature. */
#define THREAD_LIMIT 1

/* Licensed features */
extern int feature_attach;
extern int feature_unlimited_threads;
extern int feature_api;
extern int feature_burst;

/* Checkout license. Returns 0 if sucessful, otherwise returns non-0 and sets
   exit_status to an appropriate exit status. */
extern int licensing_init(am_exit_status_t *exit_status);

/* Release license. */
extern void licensing_fini(void);

/* Check if the license allows sampling of this ELF file. Returns 0 if so,
   otherwise non-0. */
extern int licensing_check_manifest(const char *elf_file);

END_EXTERN_C;
