/// @file analysis/call_stack/full_stack.cc

// Copyright (c) 2010 Acumem AB.  All rights reserved.

#include "analysis/call_stack/full_stack.hh"

#include <boost/foreach.hpp>

BEGIN_NAMESPACE(acumem);
BEGIN_NAMESPACE(analysis);

void
full_stack_node_t::destroy()
{
    if (children) {
	BOOST_FOREACH(full_stack_node_t &t, *children)
	    t.destroy();
	delete children;
    }
}

full_stack_node_t &
full_stack_node_t::find_or_create_node(const fnr_address_t &pc)
{
    if (children == 0) {
	children = new full_stack_children_vector_t;
	return *children->insert(children->begin(),
				 full_stack_node_t(pc));
    }

    full_stack_children_vector_t::iterator i = children->find(pc);
    if (i == children->end())
	i = children->insert(children->begin(),
			     full_stack_node_t(pc));
    return *i;
}

void
full_stack_node_t::deposit(
    const fnr_address_vector_t &stack,
    fnr_stack_depth_t level)
{
    count++;
    if (level-- > 0)
        find_or_create_node(stack[level]).deposit(stack, level);
}

END_NAMESPACE;
END_NAMESPACE;
