/// @file analysis/fetch_ratio/repl_fr_random.hh

// Copyright (c) 2009 Acumem AB.  All rights reserved.

#ifndef REPL_FR_RANDOM_HH
#define REPL_FR_RANDOM_HH

#include "analysis/fetch_ratio/repl_fr_engine.hh"
#include "analysis/fetch_ratio/window_rr.hh"

BEGIN_NAMESPACE(acumem);
BEGIN_NAMESPACE(analysis);

/// Fetch ratio solver for random replacement caches
class repl_fr_random_t : public repl_fr_engine_t {
public:
    static repl_fr_engine_result_cptr_t calculate(
        const sample_mapping_result_cptr_t &sample_mapping,
        const windowing_result_cptr_t &windowing,
        const window_rr_result_cptr_t &window_rr,
        fnr_line_count_t num_cache_lines);

    repl_fr_random_t(const feature_context_ptr_t &context,
                     const string &sample_file,
                     fnr_stack_depth_t stack_depth,
                     thread_mapping_cptr_t thread_mapping,
		     const windowing_engine_cptr_t &windowing,
		     const cpu_model_t &cpu_model);

    string name() const;
    string short_name() const;

protected:
    repl_fr_engine_result_cptr_t calculate_repl_fr(
	mapped_sample_type_t window_sample_type,
	mapped_sample_type_t sample_sample_type,
	fnr_line_size_t line_size,
	fnr_line_size_t page_size,
	fnr_cache_size_t cache_size,
        sample_mapping_result_cptr_t sample_mapping,
        windowing_result_cptr_t windowing,
        fnr_line_count_t num_cache_lines) const;
};

END_NAMESPACE;
END_NAMESPACE;

#endif /* REPL_FR_RANDOM_HH */
