/// @file analysis/fetch_ratio/windowing_burst.cc

// Copyright (c) 2006-2010 Acumem AB.  All rights reserved.

#include "windowing_burst.hh"
#include <boost/lexical_cast.hpp>

BEGIN_NAMESPACE(acumem);
BEGIN_NAMESPACE(analysis);

using namespace std;
using namespace boost;
using namespace acumem::library;

windowing_burst_t::windowing_burst_t()
    : windowing_engine_t()
{
}

string
windowing_burst_t::name() const
{
    return "windowing_burst_t()";
}


void
windowing_burst_t::do_windowing(
    window_vector_t &windows,
    const time_mapping_burst_t &tm_burst,
    const mapped_cold_cptr_vector_t &cold_samples,
    const mapped_repl_base_cptr_vector_t &repl_samples,
    const tm_cache_id_t cache_id) const
{
    window_ptr_t window(new window_t);

    window->begin_time = 0;
    window->end_time = tm_burst.get_last_local_time(cache_id);

    // Add the window to the vector.
    windows.resize(1);
    windows[0] = window;
}

END_NAMESPACE;
END_NAMESPACE;
