/// @file analysis/fetch_ratio/windowing_static.hh

// Copyright (c) 2008 Acumem AB.  All rights reserved.

#ifndef WINDOWING_STATIC_HH
#define WINDOWING_STATIC_HH

#include "windowing.hh"

BEGIN_NAMESPACE(acumem);
BEGIN_NAMESPACE(analysis);

using namespace std;
using namespace acumem::library;

// ----- windowing_static_t ---------------------------------------------------
class windowing_static_t
    : public windowing_engine_t
{
public:
    windowing_static_t(fnr_sample_count_t samples_per_window);

    string name() const;

    void do_windowing(
	window_vector_t &windows,
	const time_mapping_burst_t &tm_burst,
	const mapped_cold_cptr_vector_t &cold_samples,
	const mapped_repl_base_cptr_vector_t &repl_samples,
	const tm_cache_id_t cache_id) const;

private:
    const fnr_sample_count_t samples_per_window;
};

END_NAMESPACE;
END_NAMESPACE;

#endif
