/// @file analysis/filter/filter_module.hh

// Copyright (c) 2006-2008, 2010 Acumem AB.  All rights reserved.

#ifndef FILTER_MODULE_HH
#define FILTER_MODULE_HH

#include "filter.hh"
#include "analysis/misc/parser.hh"

BEGIN_NAMESPACE(acumem);
BEGIN_NAMESPACE(analysis);

using namespace acumem::library;

class filter_module_t : feature_t<parser_result_cptr_t> {
public:
    static parser_result_cptr_t calculate(
        parser_result_cptr_t in_data,
        fnr_line_size_t line_size);
    static parser_result_cptr_t calculate(
        parser_result_cptr_t in_data,
        fnr_line_size_t line_size,
        filter_ptr_t filter);

    filter_module_t(feature_context_ptr_t context,
                    const string &sample_file,
                    fnr_line_size_t line_size);
    filter_module_t(feature_context_ptr_t context,
                    const string &sample_file,
                    fnr_line_size_t line_size,
                    filter_ptr_t filter);
    parser_result_cptr_t get() const;

protected:
    string name() const;
    parser_result_cptr_t calculate() const;

private:
    const string sample_file;
    const fnr_line_size_t line_size;
    const filter_ptr_t filter;
};

END_NAMESPACE
END_NAMESPACE

#endif
