/// @file analysis/misc/result_valid.hh

// Copyright (c) 2008 Acumem AB.  All rights reserved.

#ifndef RESULT_VALID_HH
#define RESULT_VALID_HH

#include <iostream>
#include "library/lang/common_macros.h"

BEGIN_NAMESPACE(acumem);
BEGIN_NAMESPACE(analysis);

using namespace std;

class result_valid_t {
public:
    result_valid_t()
        : is_valid(false), the_value(-1.0) {};

    result_valid_t(bool valid, double value)
        : is_valid(valid), the_value(value) {}

    double value() const {
	return the_value;
    }

    bool valid() const {
	return is_valid;
    }

    bool operator==(const result_valid_t &that) const {
        return
            is_valid == that.is_valid &&
            the_value == that.the_value;
    }

private:
    bool is_valid;
    double the_value;
};

ostream &operator<<(ostream &os, const result_valid_t &rv);

END_NAMESPACE;
END_NAMESPACE;

#endif
