/// @file analysis/thread_mapping/thread_mapping.cc

// Copyright (c) 2008-2009 Acumem AB.  All rights reserved.

#include "thread_mapping.hh"
#include "analysis/filter/filter_module.hh"
#include <boost/lexical_cast.hpp>

BEGIN_NAMESPACE(acumem);
BEGIN_NAMESPACE(analysis);

tm_cache_map_t &
thread_mapping_burst_t::get_cache_map(fnr_time_t time)
{
    tm_time_cache_map_t::iterator it = time_cache_map.upper_bound(time);
    assert(it != time_cache_map.begin());
    it--;

    return  it->second;
}

const tm_cache_map_t &
thread_mapping_burst_t::get_cache_map(fnr_time_t time) const
{
    tm_time_cache_map_t::const_iterator it = time_cache_map.upper_bound(time);
    assert(it != time_cache_map.begin());
    it--;

    return  it->second;
}

tm_cache_id_t
thread_mapping_burst_t::get_cache_id(fnr_time_t time, fnr_thread_id_t tid) const
{
    const tm_cache_map_t &cm = get_cache_map(time);
    tm_cache_map_t::const_iterator it = cm.find(tid);
    assert(it != cm.end());

    return it->second;
}

END_NAMESPACE;
END_NAMESPACE;
