/// @file analysis/thread_mapping/thread_mapping_auto.cc

// Copyright (c) 2008-2009 Acumem AB.  All rights reserved.

#include "thread_mapping_auto.hh"
#include "thread_mapping_null.hh"
#include "thread_mapping_legacy.hh"
#include "thread_mapping_rr.hh"

BEGIN_NAMESPACE(acumem);
BEGIN_NAMESPACE(analysis);

thread_mapping_auto_t::thread_mapping_auto_t(feature_context_ptr_t context,
                                             const string &sample_file,
					     bool shared_cache)
    : thread_mapping(
        parser_t(context, sample_file).get()->mt_sampled() ?
        (shared_cache ?
         (thread_mapping_t *)new thread_mapping_rr_t(context, sample_file, 1) :
         (thread_mapping_t *)new thread_mapping_null_t(context, sample_file)) :
        (thread_mapping_t *)new thread_mapping_legacy_t(context, sample_file))
{
}

thread_mapping_result_cptr_t
thread_mapping_auto_t::get() const
{
    return thread_mapping->get();
}

string
thread_mapping_auto_t::name() const
{
    return thread_mapping->name();
}

END_NAMESPACE;
END_NAMESPACE;
