/// @file analysis/thread_mapping/thread_mapping_auto.hh

// Copyright (c) 2008 Acumem AB.  All rights reserved.

#ifndef THREAD_MAPPING_AUTO_HH
#define THREAD_MAPPING_AUTO_HH

#include "analysis/thread_mapping/thread_mapping.hh"

BEGIN_NAMESPACE(acumem);
BEGIN_NAMESPACE(analysis);

/**
 * Thread mapping module that acts as thread_mapping_null_t or
 * thread_mapping_rr_t with 1 cache for MP sampled sample files and
 * thread_mapping_legacy_t for non-MP sampled sample files.
 */
class thread_mapping_auto_t : public thread_mapping_t {
public:
    thread_mapping_auto_t(feature_context_ptr_t context,
                          const string &sample_file,
			  bool shared_cache = false);
    thread_mapping_result_cptr_t get() const;
    string name() const;

private:
    const thread_mapping_cptr_t thread_mapping;
};

END_NAMESPACE;
END_NAMESPACE;

#endif
