/// @file analysis/thread_mapping/thread_mapping_explicit.hh

// Copyright (c) 2008-2010 Acumem AB.  All rights reserved.

#ifndef THREAD_MAPPING_EXPLICIT_HH
#define THREAD_MAPPING_EXPLICIT_HH

#include "analysis/thread_mapping/thread_mapping.hh"

BEGIN_NAMESPACE(acumem);
BEGIN_NAMESPACE(analysis);

using namespace std;
using namespace acumem::library;

/// Module providing an explicit thread to cache mapping. Threads that have no
/// explicit mapping are allocated to the caches in round robin fashion.
class thread_mapping_explicit_t
    : public thread_mapping_t,
      public feature_t<thread_mapping_result_cptr_t> {
public:
    static thread_mapping_result_cptr_t calculate(
	feature_context_ptr_t context,
	parser_result_cptr_t parser_result,
        tm_cache_id_t num_caches,
        const tm_cache_map_t &explicit_mapping);

    thread_mapping_explicit_t(feature_context_ptr_t context,
			      const string &sample_file,
                              const tm_cache_id_t num_caches,
			      const tm_cache_map_t &explicit_mapping);
    thread_mapping_result_cptr_t get() const;

protected:
    string name() const;
    thread_mapping_result_cptr_t calculate() const;

private:
    const string sample_file;
    const tm_cache_id_t num_caches;
    const tm_cache_map_t explicit_mapping;
};

END_NAMESPACE;
END_NAMESPACE;

#endif
