/// @file analysis/thread_mapping/thread_mapping_legacy.hh

// Copyright (c) 2008, 2010 Acumem AB.  All rights reserved.

#ifndef THREAD_MAPPING_LEGACY_HH
#define THREAD_MAPPING_LEGACY_HH

#include "analysis/thread_mapping/thread_mapping.hh"

BEGIN_NAMESPACE(acumem);
BEGIN_NAMESPACE(analysis);

using namespace std;
using namespace acumem::library;

/**
 * Thread mapping for legacy files. Maps all threads to the same cache.
 */
class thread_mapping_legacy_t
    : public thread_mapping_t,
      public feature_t<thread_mapping_result_cptr_t> {
public:
    static thread_mapping_result_cptr_t calculate(
	feature_context_ptr_t context,
	parser_result_cptr_t parser_result);

    thread_mapping_legacy_t(feature_context_ptr_t context,
                            const string &sample_file);
    thread_mapping_result_cptr_t get() const;

protected:
    string name() const;
    thread_mapping_result_cptr_t calculate() const;

private:
    const string sample_file;
};

END_NAMESPACE;
END_NAMESPACE;

#endif
