/// @file analysis/thread_mapping/thread_mapping_rr.hh

// Copyright (c) 2008, 2010 Acumem AB.  All rights reserved.

#ifndef THREAD_MAPPING_RR_HH
#define THREAD_MAPPING_RR_HH

#include "analysis/thread_mapping/thread_mapping.hh"

BEGIN_NAMESPACE(acumem);
BEGIN_NAMESPACE(analysis);

using namespace std;
using namespace acumem::library;

/**
 * Module providing a static thread to cache mapping. Threads are
 * allocated, without any special priority, to a specified number of
 * caches.
 */
class thread_mapping_rr_t
    : public thread_mapping_t,
      public feature_t<thread_mapping_result_cptr_t> {
public:
    static thread_mapping_result_cptr_t calculate(
	feature_context_ptr_t context,
        parser_result_cptr_t parser_result,
        int num_caches);

    thread_mapping_rr_t(feature_context_ptr_t context,
                        const string &sample_file,
                        int num_caches);
    thread_mapping_result_cptr_t get() const;

protected:
    string name() const;
    thread_mapping_result_cptr_t calculate() const;

private:
    const string sample_file;
    const int num_caches;
};

END_NAMESPACE;
END_NAMESPACE;

#endif
