/// @file library/atf_resampler/byte_watchpoint.hh

// Copyright (c) 2009 Acumem AB.  All rights reserved.

#ifndef BYTE_WATCHPOINT_HH
#define BYTE_WATCHPOINT_HH

#include "watchpoint.hh"

// For line_watchpoint_map_t
#include "line_watchpoint.hh"

BEGIN_NAMESPACE(acumem);
BEGIN_NAMESPACE(library);

using namespace std;

/// Byte watchpoint.
struct byte_watchpoint_t : public watchpoint_t {
    byte_watchpoint_t(flow_atf_resampler_t *resampler,
		      thread_t *thread,
		      uint64_t wp_addr,
		      wp_group_t *wp_group,
		      line_watchpoint_map_t *line_wps,
		      const fnr_sample_access_t *access);

    /// Line watchpoints associated with the watchpoint.
    line_watchpoint_map_t line_wps;

    /// Live watchpoint access types.
    access_type_set_t live_wp_types;

    /// Seen access types from each thread.
    thread_access_type_set_t seen_access_types;

    /// The last access of each type from each thread.
    last_access_t last_access;

    int apply_access_impl(
	const fnr_sample_access_t *access,
	stack_t *stack,
	fnr_line_size_t line_size,
	bool must_be_last);
};

END_NAMESPACE;
END_NAMESPACE;

#endif
