/// @file library/atf_resampler/exceptions.cc

// Copyright (c) 2009 Acumem AB.  All rights reserved.

#include "exceptions.hh"

#include <sstream>

BEGIN_NAMESPACE(acumem)
BEGIN_NAMESPACE(library)

using namespace std;

string
resampler_not_enough_samples_warning_t::what() const
{
    ostringstream oss;
    oss << "Not enough samples for a reliable result. Got "
	<< num_samples << " samples, " << min_samples
        << " samples required.";

    if (num_samples > 0) {
	if (max_sample_period > desired_sample_period)
	    oss << " Consider decreasing the sample period to "
		<< desired_sample_period << ".";
	else
	    oss << " Consider decreasing the sample period to "
		<< max_sample_period << ".";
    }

    return oss.str();
}

string
resampler_not_enough_bursts_warning_t::what() const
{
    ostringstream oss;
    oss << "Not enough samples for reliable results. Got "
	<< num_samples << " samples of the largest line size. Required "
	"number of samples: " << min_samples << ".";

    if (num_samples > 0)
        oss << " Consider decreasing the estimated execution time by "
            << (int)(100.0 - 100.0 * num_samples / desired_samples) << "%.";

    return oss.str();
}

END_NAMESPACE;
END_NAMESPACE;

