/// @file library/atf_resampler/page_watchpoint.hh

// Copyright (c) 2009 Acumem AB.  All rights reserved.

#ifndef PAGE_WATCHPOINT_HH
#define PAGE_WATCHPOINT_HH

#include "watchpoint.hh"
#include "access_type.hh"

BEGIN_NAMESPACE(acumem);
BEGIN_NAMESPACE(library);

using namespace std;

/// Page watchpoint.
struct page_watchpoint_t : public watchpoint_t {
    page_watchpoint_t(flow_atf_resampler_t *resampler,
		      thread_t *thread,
		      uint64_t wp_addr,
		      wp_group_t *wp_group,
		      const fnr_sample_access_t *access);

    /// Access type that started the watchpoint.
    fnr_access_type_t start_access_type;

    /// Seen access types from each thread.
    thread_access_type_set_t seen_access_types;

    int apply_access_impl(
	const fnr_sample_access_t *access,
	stack_t *stack,
	fnr_line_size_t line_size,
	bool must_be_last);
};

END_NAMESPACE;
END_NAMESPACE;

#endif
