/// @file library/atf_resampler/watchpoint_type.hh

// Copyright (c) 2009 Acumem AB.  All rights reserved.

#ifndef WATCHPOINT_TYPE_HH
#define WATCHPOINT_TYPE_HH

#include "library/lang/common_macros.h"
#include "library/lang/common_types.h"
#include "library/fenris/fenris.hh"

BEGIN_NAMESPACE(acumem);
BEGIN_NAMESPACE(library);

using namespace std;

/// Information about a watchpoint class, i.e., byte, line or page
/// watchpoints of a specific size.
struct watchpoint_type_t {
    watchpoint_type_t(fnr_line_size_log2_t wp_size_log2)
	: wp_size_log2(wp_size_log2),
	  wp_size((fnr_line_size_t)1 <<  wp_size_log2)
	{}

    /// 2-logarithm of the watchpoint size.
    fnr_line_size_log2_t wp_size_log2;

    // Watchpoint size.
    fnr_line_size_t wp_size;
};

/// Vector of watchpoint types.
typedef vector<watchpoint_type_t *> watchpoint_type_vector_t;

END_NAMESPACE;
END_NAMESPACE;

#endif
