#include "library/cpuid/cpuid_utils.hh"

BEGIN_NAMESPACE(acumem);
BEGIN_NAMESPACE(library);

cpuid_regs_t
cpuid_eax(
    unsigned int eax)
{
    cpuid_regs_t regs(eax, 0, 0, 0);
    cpuid_os_t::cpuid(regs);

    return regs;
}

cpuid_regs_t
cpuid_cpu_eax(
    unsigned int cpu_nr,
    unsigned int eax)
{
    cpuid_regs_t regs(eax, 0, 0, 0);
    cpuid_os_t::cpuid_cpu(cpu_nr, regs);

    return regs;
}

cpuid_regs_t
cpuid_eax_ecx(
    unsigned int eax,
    unsigned int ecx)
{
    cpuid_regs_t regs(eax, 0, ecx, 0);
    cpuid_os_t::cpuid(regs);
    return regs;
}

cpuid_regs_t
cpuid_cpu_eax_ecx(
    unsigned int cpu_nr,
    unsigned int eax,
    unsigned int ecx)
{
    cpuid_regs_t regs(eax, 0, ecx, 0);
    cpuid_os_t::cpuid_cpu(cpu_nr, regs);
    return regs;
}

string
get_vendor_id()
{
    cpuid_regs_t regs(cpuid_eax(0x00000000));
    union {
        char chars[13];
        int regs[3];
    } vendor;
    vendor.regs[0] = regs.ebx;
    vendor.regs[1] = regs.edx;
    vendor.regs[2] = regs.ecx;
    vendor.chars[12] = '\0';

    return vendor.chars;
}

END_NAMESPACE;
END_NAMESPACE;
