#ifndef CPUID_UTILS_HH
#define CPUID_UTILS_HH

#include "library/cpuid/cpuid_os.hh"

#include <string>

BEGIN_NAMESPACE(acumem);
BEGIN_NAMESPACE(library);

using namespace std;

/// Run CPUID on the current logical processor.
cpuid_regs_t cpuid_eax(
    unsigned int eax);

/// Run CPUID on the specified logical processor.
cpuid_regs_t cpuid_cpu_eax(
    unsigned int cpu_nr,
    unsigned int eax);

/// Run CPUID on the current logical processor.
cpuid_regs_t cpuid_eax_ecx(
    unsigned int eax,
    unsigned int ecx);

/// Run CPUID on the specified logical processor.
cpuid_regs_t cpuid_cpu_eax_ecx(
    unsigned int cpu_nr,
    unsigned int eax,
    unsigned int ecx);

/// Return the vendor ID.
string get_vendor_id();

END_NAMESPACE;
END_NAMESPACE;

#endif
