/// @file library/fenris/flow_file_reader.cc

// Copyright (c) 2006-2009 Acumem AB.  All rights reserved.

#define __STDC_LIMIT_MACROS

#include "flow_file_reader.hh"

BEGIN_NAMESPACE(acumem);
BEGIN_NAMESPACE(library);

namespace fs = boost::filesystem;

flow_file_reader_t::flow_file_reader_t(
    const fs::path &filename,
    fenris_flow_t *flow_next,
    warning_consumer_ptr_t warning_consumer)
    : decoder(flow_next, warning_consumer),
      container_stream(&decoder, warning_consumer),
      file_stream(filename, &container_stream)
{
    /* The file reader holds a private chain of stream modules and a decoder:
     * file_stream_reader -> stream_container -> decoder_binary
     */
}

flow_file_reader_t::flow_file_reader_t(
    FILE *f,
    fenris_flow_t *flow_next,
    warning_consumer_ptr_t warning_consumer)
    : decoder(flow_next, warning_consumer),
      container_stream(&decoder, warning_consumer),
      file_stream(f, &container_stream)
{
    /* The file reader holds a private chain of stream modules and a decoder:
     * file_stream_reader -> stream_container -> decoder_binary
     */
}

flow_file_reader_t::~flow_file_reader_t()
{
}

const stream_container_header_t &
flow_file_reader_t::get_header()
{
    return container_stream.get_header();
}

stream_status_t
flow_file_reader_t::dispatch()
{
    return file_stream.dispatch();
}

END_NAMESPACE;
END_NAMESPACE;
