/// @file library/fenris/flow_printer.hh

// Copyright (c) 2007-2009 Acumem AB.  All rights reserved.

#ifndef FLOW_PRINTER_HH
#define FLOW_PRINTER_HH

#include "flow.hh"
#include "library/lang/common_macros.h"

BEGIN_NAMESPACE(acumem);
BEGIN_NAMESPACE(library);

using namespace std;

/**
 * Fenris printer. Processes events from a fenris event flow and prints them
 * to a stream.
*/
class flow_printer_t
    : public fenris_flow_t
{
public:
    flow_printer_t(ostream &os);

    flow_status_t flow_init(fnr_features_t features);
    flow_status_t process_event(const fnr_event_t &event);

private:
    ostream &os;
};

END_NAMESPACE;
END_NAMESPACE;

#endif
