#ifndef MANIFEST_HH
#define MANIFEST_HH

#include "library/sha1/sha1.hh"

BEGIN_NAMESPACE(acumem);
BEGIN_NAMESPACE(library);

using namespace std;

class manifest_exception_t : public exception {
public:
    manifest_exception_t(const string &message)
        : message(message)
        {}

    ~manifest_exception_t() throw() {
    }

    const char *what() const throw() {
        return message.c_str();
    }

private:
    const string message;
};

/// Verifys that a valid manifest can be found for the specified file and
/// returns the SHA1 digest of the manifest file. Throws manifest_exception_t
/// if no valid manifest can be found, or if an error occurs.
sha1_t verify_manifest(const string &filename);

END_NAMESPACE;
END_NAMESPACE;

#endif
