#ifndef SHA1_HH
#define SHA1_HH

#include "library/lang/common_macros.h"

#include <string>

BEGIN_NAMESPACE(acumem);
BEGIN_NAMESPACE(library);

using namespace std;

class sha1_exception_t : public exception {
public:
    sha1_exception_t(const string &message)
        : message(message)
        {}

    ~sha1_exception_t() throw() {
    }

    const char *what() const throw() {
        return message.c_str();
    }

private:
    const string message;
};

class sha1_t {
public:
    unsigned char bytes[20];
};

/// Calculates and returns the SHA-1 digest of the specified file. Throws
/// sha1_exception_t on error.
sha1_t calculate_sha1(const string &filename);

/// Returns the string representation of the specified SHA-1 digest.
string sha1_as_string(const sha1_t &sha1);

END_NAMESPACE;
END_NAMESPACE;

#endif
