/// @file library/stream/header_collector.hh

// Copyright (c) 2011 Acumem AB.  All rights reserved.

#ifndef HEADER_COLLECTOR_HH
#define HEADER_COLLECTOR_HH

BEGIN_NAMESPACE(acumem);
BEGIN_NAMESPACE(library);

class header_collector_t {
public:
    header_collector_t(
        const string &path,
        warning_consumer_ptr_t warning_consumer) {
	stream_aborter_t out;
	stream_container_reader_t container(&out, warning_consumer);
	stream_file_reader_t in(path.c_str(), &container);

	in.dispatch();
	header = container.get_header();
    }

    stream_container_header_t header;

private:
    class stream_aborter_t
	: public stream_t
    {
    public:
	stream_aborter_t()
	    : stream_t() {}

	stream_status_t process_data(const char *buffer, size_t len) {
	    return STREAM_ABORT;
	}

	stream_status_t flush() {
	    return STREAM_OK;
	}
    };
};

END_NAMESPACE;
END_NAMESPACE;

#endif /* HEADER_COLLECTOR_HH */
