/// @file library/sym/cppfilt.hh

// Copyright (c) 2008, 2010 Acumem AB.  All rights reserved.

#ifndef CPPFILT_HH
#define CPPFILT_HH

#include "library/lang/common_macros.h"

#include <list>
#include <string>

#include <boost/shared_ptr.hpp>

BEGIN_NAMESPACE(acumem);
BEGIN_NAMESPACE(library);

using namespace std;
using boost::shared_ptr;

// ----------------------------------------------------------------------

BEGIN_NAMESPACE(detail);

// For now, hide the process manager in this "private" namespace

class process_t;

class process_exception_t : public std::exception {
public:
    process_exception_t(const char *where, int saved_errno) {}

};

END_NAMESPACE; // detail


class cppfilt_t {
public:
    cppfilt_t(const char *cppfilt_path);
    string translate(const string &symbol);

private:
    shared_ptr<detail::process_t> cppfilt_process;
};



END_NAMESPACE;
END_NAMESPACE;

#endif

