/// @file library/sym/libdwarf_object.cc

// Copyright (c) 2008 Acumem AB.  All rights reserved.

#include "libdwarf_object.hh"

BEGIN_NAMESPACE(acumem);
BEGIN_NAMESPACE(library);

Dwarf_Obj_Access_Methods_s libdwarf_object_t::methods = {
    &libdwarf_object_t::get_section_info_s,
    &libdwarf_object_t::get_byte_order_s,
    &libdwarf_object_t::get_length_size_s,
    &libdwarf_object_t::get_pointer_size_s,
    &libdwarf_object_t::get_section_count_s,
    &libdwarf_object_t::load_section_s,
};

bool
libdwarf_object_t::init(Dwarf_Obj_Access_Interface_s *s)
{
    if (!specific_init())
	return false;
    s->object = this;
    s->methods = &methods;

    return true;
}

END_NAMESPACE;
END_NAMESPACE;
