/// @file library/sym/sym_binary.cc

// Copyright (c) 2010 Acumem AB.  All rights reserved.

#include "sym_binary.hh"

using namespace std;
using namespace boost;

BEGIN_NAMESPACE(acumem);
BEGIN_NAMESPACE(library);

void
sym_binary_t::lookup_sym_info(sym_paddr_t address,
                              sym_info_ptr_t &sym_info)
{
    sym_info->binary_file = filename;
    sym_info->binary_offset = address.paddr - range.base.paddr;
}

sym_binary_t::sym_binary_t(sym_t &sym,
                           sym_paddr_t base,
                           sym_paddr_t end,
                           const string &filename)
    : sym_base_t(sym, base, end),
      filename(string_cache_lookup(filename))
{
}

END_NAMESPACE;
END_NAMESPACE;
