/** @file library/version/version.c */

/* Copyright (c) 2007, 2009 Acumem AB.  All rights reserved. */

// Get MSVC to not complain about strncpy().
#define _CRT_SECURE_NO_WARNINGS

#include "version.h"

#include <string.h>

void
version_get_svnversion(char *buf, int size)
{
    const char *p = svn_version;
    char *q;
    while (*p && *p != ' ')
	p++;
    p++; /* skip space */

    strncpy(buf, p, size);
    buf[size-1] = 0;
    q = strchr(buf, ' ');
    if (q)
	*q = 0;
}

void
version_get_svnpath(char *buf, int size)
{
    const char *p = svn_path;
    char *q;
    while (*p && *p != ' ')
	p++;
    p++; /* skip space */

    strncpy(buf, p, size);
    buf[size-1] = 0;
    q = strchr(buf, ' ');
    if (q)
	*q = 0;
}

void
version_get_svnpath_last_component(char *buf, int size)
{
    const char *p = strrchr(svn_path, '/');
    char *q;
    if (p) {
	p++;

	strncpy(buf, p, size);
	buf[size-1] = 0;
	q = strchr(buf, ' ');
	if (q)
	    *q = 0;
    } else {
	strncpy(buf, "unknown", size);
    }
}
