/** @file library/version/version.h */

/* Copyright (c) 2007-2008 Acumem AB.  All rights reserved. */

#ifndef INCLUDED_VERSION_H
#define INCLUDED_VERSION_H

#ifdef __cplusplus
extern "C" {
#endif

extern const char *svn_version;
extern const char *svn_path;
extern unsigned int version_compile_time;

void version_get_svnversion(char *buf, int size);
void version_get_svnpath(char *buf, int size);
void version_get_svnpath_last_component(char *buf, int size);


/* This function is never called. It exists just to bring in the
 * version attributes from the libversion32.a */
#ifdef _WIN32
#define BRING_IN_VERSIONINFO \
    extern volatile void *version_bring_in_version_info = &svn_version;
#else
#define BRING_IN_VERSIONINFO \
    __attribute__((used)) const char *		\
    version_bring_in_version_info()		\
    {						\
	return svn_version;			\
    }

#endif

#ifdef __cplusplus
}
#endif
#endif
