/** @file sampler/src/am_registers.h */

/* Copyright (c) 2007, 2009-2011 Rogue Wave Software, Inc.  All rights reserved. */

#ifndef AM_REGISTERS_H
#define AM_REGISTERS_H

#include "am_stdint.h"

/* Must be identical for 32-bit and 64-bit target. */
typedef struct am_registers {
    uint64_t rflags;
    uint64_t rip;
    uint64_t rax;
    uint64_t rcx;
    uint64_t rdx;
    uint64_t rbx;
    uint64_t rsp;
    uint64_t rbp;
    uint64_t rsi;
    uint64_t rdi;
    uint64_t r8;
    uint64_t r9;
    uint64_t r10;
    uint64_t r11;
    uint64_t r12;
    uint64_t r13;
    uint64_t r14;
    uint64_t r15;
    uint16_t segreg;
    uint8_t pad[6];
} am_registers_t;

#endif /* AM_REGISTERS_H */
