/// @file tools/acurate/csv.cc

// Copyright (c) 2007-2009 Acumem AB.  All rights reserved.

#include "csv.hh"

#include <boost/lexical_cast.hpp>
#include <boost/foreach.hpp>

#include <fstream>

BEGIN_NAMESPACE(acumem);
BEGIN_NAMESPACE(acurate);

void
csv_t::write_csv_file(const std::string &filename) const
{
    ofstream f(filename.c_str());
    q(f, name);

    BOOST_FOREACH(const private_series_t &s, series_list) {
	f << delim;
	q(f, s.name);
    }
    f << endl;

    const rpt_sweep_t &sweep(report->sweeps.at(sweep_id));

    for (uint32_t i = 0; i < sweep.size(); i++) {
	q(f, boost::lexical_cast<string>(sweep.at(i)));
	BOOST_FOREACH(const private_series_t &s, series_list) {
	    f << delim;
	    q(f, boost::lexical_cast<string>(
                  s.data.size() > i ? s.data[i] : 0.0));
	}
	f << endl;
    }
}

END_NAMESPACE;
END_NAMESPACE;
