/// @file tools/acurate/html_block.hh

// Copyright (c) 2007-2009 Acumem AB.  All rights reserved.

#ifndef INCLUDED_HTML_BLOCK
#define INCLUDED_HTML_BLOCK

#include "issue.hh"

BEGIN_NAMESPACE(acumem);
BEGIN_NAMESPACE(acurate);

using namespace acumem::analysis;

class html_block_t : public html_issue_t {
public:
    html_block_t(html_context_t &html_context,
		 rpt_issue_id_t issue_id);

    void emit_summary(xml_file_t &xml,
                      summary_context_t &summary_context,
                      summary_type_t summary_type);

    void emit_issue_file(xml_file_t &issue_xml);

    void annotate_source();

    summary_type_bitset_t summary_type() const;

    string get_name() const;
    string get_icon() const;

private:
    const rpt_block_issue_t &get_issue() const {
        return *(rpt_block_issue_t *)html_context.report->issues.at(issue_id).get();
    }
};

END_NAMESPACE;
END_NAMESPACE;

#endif
