/// @file tools/acurate/html_comm_utilization.hh

// Copyright (c) 2008-2009 Acumem AB.  All rights reserved.

#ifndef INCLUDED_HTML_COMM_UTILIZATION
#define INCLUDED_HTML_COMM_UTILIZATION

#include "issue.hh"
#include "file_png.hh"
#include "../loop_info.hh"

BEGIN_NAMESPACE(acumem);
BEGIN_NAMESPACE(acurate);

class html_comm_utilization_t : public html_issue_t {
public:
    html_comm_utilization_t(html_context_t &html_context,
			    rpt_issue_id_t issue_id);

    void emit_summary(xml_file_t &xml,
                      summary_context_t &summary_context,
                      summary_type_t summary_type);

    void emit_issue_file(xml_file_t &issue_xml);

    void annotate_source();

    summary_type_bitset_t summary_type() const;

    string get_name() const {
        return TEXT_COMM_UTILIZATION;
    }

    string get_icon() const;

private:
    const rpt_comm_utilization_issue_t &get_issue() const {
        return *(rpt_comm_utilization_issue_t *)html_context.report->issues.at(issue_id).get();
    }
};

END_NAMESPACE;
END_NAMESPACE;

#endif
