/// @file tools/acurate/html_false_sharing.hh

// Copyright (c) 2008-2009 Acumem AB.  All rights reserved.

#ifndef INCLUDED_HTML_FALSE_SHARING
#define INCLUDED_HTML_FALSE_SHARING

#include "issue.hh"
#include "file_png.hh"
#include "../loop_info.hh"

BEGIN_NAMESPACE(acumem);
BEGIN_NAMESPACE(acurate);

class html_false_sharing_t : public html_issue_t {
public:
    html_false_sharing_t(html_context_t &html_context,
			 rpt_issue_id_t issue_id);

    void emit_summary(xml_file_t &xml,
                      summary_context_t &summary_context,
                      summary_type_t summary_type);

    void emit_issue_file(xml_file_t &issue_xml);

    void annotate_source();

    summary_type_bitset_t summary_type() const;

    string get_name() const {
        return TEXT_FALSE_SHARING;
    }

    string get_icon() const;

private:
    const rpt_false_sharing_issue_t &get_issue() const {
        return *(rpt_false_sharing_issue_t *)html_context.report->issues.at(issue_id).get();
    }
};

END_NAMESPACE;
END_NAMESPACE;

#endif
