/// @file tools/acurate/html_fusion.hh

// Copyright (c) 2007-2009 Acumem AB.  All rights reserved.

#ifndef INCLUDED_HTML_FUSION
#define INCLUDED_HTML_FUSION

#include "issue.hh"
#include "file_png.hh"

BEGIN_NAMESPACE(acumem);
BEGIN_NAMESPACE(acurate);

using namespace acumem::analysis;

class html_fusion_t : public html_issue_t {
public:
    html_fusion_t(html_context_t &html_context,
		  rpt_issue_id_t issue_id);

    void emit_summary(xml_file_t &xml,
                      summary_context_t &summary_context,
                      summary_type_t summary_type);

    void emit_issue_file(xml_file_t &issue_xml);

    void annotate_source();

    void link_with_role(xml_file_t &xml, int role) const;

    summary_type_bitset_t summary_type() const;

    string get_name() const {
        return expert ? TEXT_FUSION_EXPERT : TEXT_FUSION;
    }

    string get_icon() const;

private:
    const rpt_loop_fusion_issue_t &get_issue() const {
        return *(rpt_loop_fusion_issue_t *)html_context.report->issues.at(issue_id).get();
    }

    const bool expert;
};

END_NAMESPACE;
END_NAMESPACE;

#endif
