/// @file tools/acurate/html_loop.hh

// Copyright (c) 2009 Acumem AB.  All rights reserved.

#ifndef INCLUDED_HTML_LOOP
#define INCLUDED_HTML_LOOP

#include "../loop_info.hh"
#include "../xml_file.hh"
#include "../html_context.hh"
#include "issue.hh"

BEGIN_NAMESPACE(acumem);
BEGIN_NAMESPACE(acurate);

using namespace acumem::analysis;

struct loop_summary_context_t {
    loop_summary_context_t()
	: alt(false) {}

    bool alt;
};

class html_loop_t
    : public html_util_t
{
public:
    html_loop_t(html_context_t &html_context,
		const loop_info_ptr_t &loop);
    ~html_loop_t();

    void emit_summary(xml_file_t &xml,
		      loop_summary_context_t &summary_context);

    void emit_loop_file(xml_file_t &xml_loop);

private:
    void emit_depgroup_summary_line(xml_file_t &xml,
				    const depgroup_info_ptr_t &d,
				    int local_depgroup_id,
				    bool alt);
    void emit_depgroup_summary(xml_file_t &xml);
    void emit_depgroup_section(xml_file_t &xml,
			       const depgroup_info_ptr_t &d,
			       const fr_location_info_vector_t &loop_locations,
			       int local_depgroup_id);
    void emit_issues_section(xml_file_t &xml);


    html_context_t &html_context;
    loop_info_ptr_t loop;
};

END_NAMESPACE;
END_NAMESPACE;

#endif
