/// @file tools/acurate/html_order.hh

// Copyright (c) 2007-2009 Acumem AB.  All rights reserved.

#ifndef INCLUDED_HTML_ORDER
#define INCLUDED_HTML_ORDER

#include "issue.hh"
#include "file_png.hh"
#include "../loop_info.hh"

BEGIN_NAMESPACE(acumem);
BEGIN_NAMESPACE(acurate);

using namespace acumem::analysis;

class html_order_t : public html_issue_t {
public:
    html_order_t(html_context_t &html_context,
		 rpt_issue_id_t issue_id);

    void emit_summary(xml_file_t &xml,
                      summary_context_t &summary_context,
                      summary_type_t summary_type);

    void emit_issue_file(xml_file_t &issue_xml);

    void annotate_source();

    summary_type_bitset_t summary_type() const;

    string get_name() const {
        return TEXT_LOOPORDER;
    }

    string get_icon() const;

private:
    const rpt_loop_order_issue_t &get_issue() const {
        return *(rpt_loop_order_issue_t *)html_context.report->issues.at(issue_id).get();
    }
};

END_NAMESPACE;
END_NAMESPACE;

#endif
