/// @file tools/acurate/html_utilization.hh

// Copyright (c) 2008-2009 Acumem AB.  All rights reserved.

#ifndef INCLUDED_HTML_UTILIZATION
#define INCLUDED_HTML_UTILIZATION

#include "issue.hh"
#include "file_png.hh"

BEGIN_NAMESPACE(acumem);
BEGIN_NAMESPACE(acurate);

using namespace acumem::analysis;

class html_utilization_t : public html_issue_t {
public:
    html_utilization_t(html_context_t &html_context,
		       rpt_issue_id_t issue_id);

    void emit_summary(xml_file_t &xml,
                      summary_context_t &summary_context,
                      summary_type_t summary_type);

    void emit_issue_file(xml_file_t &issue_xml);

    void annotate_source();

    summary_type_bitset_t summary_type() const;

    string get_name() const;
    string get_icon() const;

private:
    const rpt_utilization_issue_t &get_issue() const {
        return *(rpt_utilization_issue_t *)html_context.report->issues.at(issue_id).get();
    }

    string get_help() const;
};

END_NAMESPACE;
END_NAMESPACE;

#endif
