/// @file tools/acurate/html_advice_consumer.hh

// Copyright (c) 2007-2010 Acumem AB.  All rights reserved.

#ifndef INCLUDED_HTML_ADVICE_CONSUMER_HH
#define INCLUDED_HTML_ADVICE_CONSUMER_HH

#include "conf.hh"
#include "file_repos.hh"
#include "xml_file.hh"
#include "drill_down.hh"
#include "loop_info.hh"
#include "analysis/report/report.hh"
#include "analysis/filter/filter_builder.hh"
#include "analysis/feature_base/exceptions.hh"

BEGIN_NAMESPACE(acumem);
BEGIN_NAMESPACE(acurate);

using namespace acumem::analysis;

class html_advice_consumer_t
    : public html_util_t
{
public:
    html_advice_consumer_t(
        html_context_t &html_context);

    void write_report();

private:
    void rank_issues();

    // high level functions to output files
    void write_issue_files();
    void write_loop_files();
    void write_annotated_source_files();
    void collect_drill_down_info();
    void write_drill_down_files();
    void write_intro_file();
    void write_frameset_file(bool has_separate_intro_file);
    void write_left_frame();

    // HTML subsections

    void insert_summary_diagrams(xml_file_t &xml,
				 int rows);

    html_context_t &html_context;

    drill_down_list_t drill_down_list;
};

END_NAMESPACE;
END_NAMESPACE;

#endif
