/// @file tools/acurate/html_context.cc

// Copyright (c) 2007, 2009 Acumem AB.  All rights reserved.

#include "html_context.hh"
#include "product.h"
#include <boost/filesystem.hpp>

#include <boost/lexical_cast.hpp>

BEGIN_NAMESPACE(acumem);
BEGIN_NAMESPACE(acurate);

using namespace std;
using namespace boost;
using namespace boost::filesystem;

string
html_context_t::report_title() const
{
    string title = report->title;
    // Default title is application name plus cache parameters
    if (title == "") {
	title = PRODUCT_NAME;
	if (report->argv.size() > 0) {
	    path p(report->argv[0]);
	    title += ": " + p.filename().string();
	}
	title += " (" +
	    value_to_string((double)report->cache_size) + "/" +
	    value_to_string((double)report->line_size) + ")";
    }
    return title;
}

END_NAMESPACE;
END_NAMESPACE;
