#ifndef ACURATE_SERVER_DYN_CONTENT_FACTORY_HH
#define ACURATE_SERVER_DYN_CONTENT_FACTORY_HH

#include "library/lang/common_macros.h"

#include <pion/net/WebService.hpp>
#include <pion/net/HTTPResponseWriter.hpp>
#include <boost/shared_ptr.hpp>
#include <map>
#include <string>

BEGIN_NAMESPACE(acumem);
BEGIN_NAMESPACE(acurate);
BEGIN_NAMESPACE(server);

class session_t;
typedef boost::shared_ptr<session_t> session_ptr_t;
class session_collection_t;

class dyn_content_t : public pion::net::WebService {
public:
    dyn_content_t(session_collection_t &session_collection,
		  session_ptr_t session);

    void operator() (pion::net::HTTPRequestPtr &request,
		     pion::net::TCPConnectionPtr &tcp_conn);

private:
    void send_not_found_response(pion::net::HTTPRequestPtr &http_request,
				 pion::net::TCPConnectionPtr &tcp_conn);
    void send_license_error_response(pion::net::HTTPRequestPtr& http_request,
				     pion::net::TCPConnectionPtr& tcp_conn);

    session_collection_t &session_collection;
    session_ptr_t session;
    pion::net::WebService *chain;
};


END_NAMESPACE;
END_NAMESPACE;
END_NAMESPACE;

#endif
