#include "url_repository.hh"
#include "session.hh"

BEGIN_NAMESPACE(acumem);
BEGIN_NAMESPACE(acurate);
BEGIN_NAMESPACE(server);

void
url_repository_t::add_dispatcher(const std::string &relative_url,
				 dispatch_function_t f)
{
    /// XXX Lock here!
    dispatch_map.insert(std::make_pair(relative_url, f));
}

bool
url_repository_t::dispatch(session_collection_t &session_collection,
			   session_ptr_t session,
			   const std::string &relative_url,
			   std::ostream &os,
			   std::string &mime_type)
{
    dispatch_function_t func;
    {
	/// XXX Lock here!
	dispatch_map_t::iterator i = dispatch_map.upper_bound(relative_url);
	if (i == dispatch_map.begin())
	    return false;
	i--;
	if (relative_url.compare(0, i->first.length(), i->first) != 0)
	    return false;
	func = i->second;
    }
    func(session_collection, session, relative_url, os, mime_type);
    return true;
}

END_NAMESPACE;
END_NAMESPACE;
END_NAMESPACE;
