/// @file tools/acurate/view_feedback.hh

// Copyright (c) 2011 Acumem AB.  All rights reserved.

#ifndef VIEW_FEEDBACK_HH
#define VIEW_FEEDBACK_HH

#include "library/feedback/licensed_feedback.hh"
#include "library/license/license.hh"

using namespace acumem::library;
using namespace acumem::license;

class view_feedback_t : public licensed_feedback_t {
public:
    view_feedback_t(license_manager_ptr_t license);

    void conditional_new_line();

    int add_major_step(const std::string &message);

    void select_major_step(int step);

    void set_minor_steps(int s);

    void update(int completed_minor_steps, const std::string &message);

    void log(log_type_t type, const string &message);

private:
    bool last_was_minor;
    int steps;
    vector<string> phases;
};

#endif /* VIEW_FEEDBACK_HH */
