/// @file tools/sample_gui/line_size_selector.hh

// Copyright (c) 2007-2008 Acumem AB.  All rights reserved.

#ifndef LINE_SIZE_SELECTOR_HH
#define LINE_SIZE_SELECTOR_HH

#include <string>

#include <gtk/gtk.h>

#include "sampler/src/sampler_limits.h"

// Sampling line size selection dialog box.
class line_size_selector_t {
public:
    line_size_selector_t(GtkWidget *parent_win);
    ~line_size_selector_t();

    // Show the dialog box.
    void show();

    // Return the selected line sizes separated by commas.
    std::string line_sizes();

    // Return the number of selected line sizes.
    int num_line_sizes();

    // Sets the analysis line size, this line size will always be
    // selected. Set to 0 to disable this feature.
    void set_analysis_line_size(unsigned int line_size);

private:
    GtkWidget *dialog;
    GtkWidget *line_size_cbutton[13];

    unsigned int analysis_line_size2;
};

#endif /* LINE_SIZE_SELECTOR_HH */
