/// @file tools/sample_gui/paths.cc

// Copyright (c) 2007-2010 Acumem AB.  All rights reserved.

#include "paths.hh"
#include "library/exe_path/exe_path.hh"
#include "product.h"

using namespace std;
using namespace boost::filesystem;

const char *paths_t::xterms[] = {
    "xterm",
    "/usr/openwin/bin/xterm",
    NULL
};

paths_t::paths_t()
{
    path exec_filename = acumem::exe_path::get_executable_filename();
    string exec_basename = make_string(g_path_get_basename(exec_filename.string().c_str()));

    bin_dir = make_string(g_path_get_dirname(exec_filename.c_str()));
    prefix_dir = bin_dir + "/..";
    pkglib_dir = prefix_dir + "/lib/threadspotter";
    data_dir = prefix_dir + "/share/threadspotter/" + exec_basename;
    pkgdata_dir = prefix_dir + "/share/threadspotter";
    acurate_data_dir = pkgdata_dir + "/report";

    rw_icon32x32 = data_dir + "/icon_rw_32x32.png";

    cpudb = pkgdata_dir + "/cpudb.xml";

    sample_script = bin_dir + "/sample";
    report = bin_dir + "/report";
    view = bin_dir + "/view";
    env_helper = pkglib_dir + "/env_helper";

    xterm = get_app(xterms);
}

paths_t::~paths_t()
{
}

string
paths_t::make_string(gchar *g_string)
{
    if (g_string) {
	string str = string((char*)g_string);
	g_free(g_string);
	return str;
    } else
	return "";
}

string
paths_t::get_app(const char *cmds[])
{
    for (int i = 0; cmds[i]; i++) {
	gchar *cmd = g_find_program_in_path(cmds[i]);
	if(cmd)
	    return make_string(cmd);
    }

    return "";
}
