/// @file tools/sample_gui/pid_selector.hh

// Copyright (c) 2007-2008 Acumem AB.  All rights reserved.

#ifndef PID_SELECTOR_HH
#define PID_SELECTOR_HH

#include <gtk/gtk.h>
#include <string>


// Sampling line size selection dialog box.
class pid_selector_base_t {
public:
    pid_selector_base_t(GtkWidget *parent_win);
    virtual ~pid_selector_base_t();

    // Show the dialog box.
    virtual bool show();
    virtual pid_t get_selected_pid();

protected:
    enum {
	COLUMN_PID,
	COLUMN_CMDLINE,
	N_COLUMNS
    };

    virtual bool update_list() = 0;

    void append_process(int pid, const char *cmd);
    void display_error(const int errnum, const char *msg);
    bool is_str_int(const char *txt);

    GtkWidget *dialog;
    GtkTreeView *list;
    GtkListStore *list_store;

private:
    static void on_pid_changed(GtkTreeSelection *selection, gpointer user_data);
};

#endif /* PID_SELECTOR_HH */
