/// @file tools/sampler_sim/sampler_sim_st.cc

// Copyright (c) 2008 Acumem AB.  All rights reserved.

#include "sampler_sim.hh"

#include <assert.h>

st_sampler_t::st_wp_t::st_wp_t(
    unsigned long address,
    unsigned int size,
    unsigned long long wp_id,
    unsigned long long wp_group_id)
    : wp_t(address, size, wp_id, wp_group_id)
{
}

bool
st_sampler_t::st_wp_t::event(
    unsigned long long access_id,
    events_t *events,
    unsigned long access_tid,
    access_type_t access_type,
    unsigned int offset,
    unsigned int size,
    bool side_effects)
{
    events->insert(make_pair(0, access_id));
    return true;
}

bool
st_sampler_t::st_wp_t::remove(
    unsigned long access_tid,
    access_type_t access_type)
{
    return true;
}

st_sampler_t::st_sampler_t(unsigned long sample_period,
                           filter_t *filter)
    : sampler_t(sample_period, filter)
{
}

wp_t *
st_sampler_t::sample_page_access(
    unsigned long index,
    access_type_t access_type,
    unsigned long access_tid,
    unsigned long long wp_id,
    unsigned long long wp_group_id)
{
    st_wp_t *wp = new st_wp_t(index * PAGE_SIZE, PAGE_SIZE, wp_id, wp_group_id);
    filter->add(wp);
    return wp;
}

wp_t *
st_sampler_t::sample_line_access(
    unsigned long index,
    access_type_t access_type,
    unsigned long access_tid,
    unsigned long long wp_id,
    unsigned long long wp_group_id)
{
    st_wp_t *wp = new st_wp_t(index * LINE_SIZE, LINE_SIZE, wp_id, wp_group_id);
    filter->add(wp);
    return wp;
}

wp_t *
st_sampler_t::sample_byte_access(
    unsigned long index,
    access_type_t access_type,
    unsigned long access_tid,
    wp_t *line_wp,
    unsigned long long wp_id,
    unsigned long long wp_group_id)
{
    st_wp_t *wp = new st_wp_t(index, 1, wp_id, wp_group_id);
    filter->add(wp);
    return wp;
}
